Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis/3.4/SingleObjective/SymbolicTimeSeriesPrognosisSingleObjectiveProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis/3.4/SingleObjective/SymbolicTimeSeriesPrognosisSingleObjectiveProblem.cs	(revision 6809)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.TimeSeriesPrognosis/3.4/SingleObjective/SymbolicTimeSeriesPrognosisSingleObjectiveProblem.cs	(revision 6811)
@@ -62,6 +62,15 @@
       MaximumSymbolicExpressionTreeLength.Value = InitialMaximumTreeLength;
 
+      SymbolicExpressionTreeGrammarParameter.ValueChanged += (o, e) => ConfigureGrammarSymbols();
+
+      ConfigureGrammarSymbols();
+
       InitializeOperators();
       UpdateEstimationLimits();
+    }
+    
+    private void ConfigureGrammarSymbols() {
+      var grammar = SymbolicExpressionTreeGrammar as TypeCoherentExpressionGrammar;
+      if (grammar != null) grammar.ConfigureAsDefaultTimeSeriesPrognosisGrammar();
     }
 
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisVariableFrequencyAnalyzer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisVariableFrequencyAnalyzer.cs	(revision 6809)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisVariableFrequencyAnalyzer.cs	(revision 6811)
@@ -80,5 +80,4 @@
       ItemArray<ISymbolicExpressionTree> expressions = SymbolicExpressionTreeParameter.ActualValue;
       ResultCollection results = ResultCollection;
-      DoubleMatrix impacts;
       DataTable datatable;
       if (VariableFrequenciesParameter.ActualValue == null) {
@@ -86,12 +85,9 @@
         datatable.VisualProperties.XAxisTitle = "Generation";
         datatable.VisualProperties.YAxisTitle = "Relative Variable Frequency";
-        impacts = new DoubleMatrix();
         VariableFrequenciesParameter.ActualValue = datatable;
-        VariableImpactsParameter.ActualValue = impacts;
         results.Add(new Result("Variable frequencies", "Relative frequency of variable references aggregated over the whole population.", datatable));
-        results.Add(new Result("Variable impacts", "The relative variable relevance calculated as the average relative variable frequency over the whole run.", impacts));
-      }
-
-      impacts = VariableImpactsParameter.ActualValue;
+        results.Add(new Result("Variable impacts", "The relative variable relevance calculated as the average relative variable frequency over the whole run.", new DoubleMatrix()));
+      }
+
       datatable = VariableFrequenciesParameter.ActualValue;
       // all rows must have the same number of values so we can just take the first
@@ -117,5 +113,6 @@
                            .OrderByDescending(p => p.Impact)
                            .ToList();
-      var matrix = (IStringConvertibleMatrix)impacts;
+      var impacts = new DoubleMatrix();
+      var matrix = impacts as IStringConvertibleMatrix;
       matrix.Rows = orderedImpacts.Count;
       matrix.RowNames = orderedImpacts.Select(x => x.Name);
@@ -127,4 +124,6 @@
       }
 
+      VariableImpactsParameter.ActualValue = impacts;
+      results["Variable impacts"].Value = impacts;
       return base.Apply();
     }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 6809)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 6811)
@@ -192,4 +192,11 @@
       Symbols.Where(s => s.Name == TimeSeriesSymbolsName).First().Enabled = false;
     }
+
+    public void ConfigureAsDefaultTimeSeriesPrognosisGrammar() {
+      Symbols.Where(s => s is Variable).First().Enabled = false;
+      Symbols.Where(s => s.Name == TrigonometricFunctionsName).First().Enabled = false;
+      Symbols.Where(s => s.Name == PowerFunctionsName).First().Enabled = false;
+      Symbols.Where(s => s.Name == ConditionalSymbolsName).First().Enabled = false;
+    }
   }
 }